//
//  ShareInstance.m
//  TestDemo
//
//  Created by lisonglin on 2018/1/17.
//  Copyright © 2018年 lisonglin. All rights reserved.
//

#import "ShareInstance.h"

static ShareInstance * _shareInstance = nil;

@implementation ShareInstance

#pragma mark -- 线程锁

+ (instancetype)shareInstance {
    @synchronized (self) {
        if (_shareInstance == nil) {
            _shareInstance = [[super allocWithZone:NULL] init];
        }
    }
    return _shareInstance;
}

#pragma mark -- GCD
/*
+ (instancetype)shareInstance {
    static dispatch_once_t onceToken;
    dispatch_once(&onceToken, ^{
        _shareInstance = [[super allocWithZone:NULL] init];
    });
    return _shareInstance;
}
*/
+ (instancetype)allocWithZone:(struct _NSZone *)zone {
    return [ShareInstance shareInstance];
}

+ (id) copyWithZone:(struct _NSZone *)zone
{
    return [ShareInstance shareInstance] ;
}



@end
