//
//  ViewController.m
//  TestDemo
//
//  Created by lisonglin on 15/08/2017.
//  Copyright © 2017 lisonglin. All rights reserved.
//

#import "ViewController.h"
#import <Foundation/Foundation.h>

@interface ViewController ()<UITableViewDelegate, UITableViewDataSource>

@property(nonatomic, strong) NSArray * dataSource;

@property(nonatomic, weak) UITableView * tableView;

@property(nonatomic, strong) UITableView * bottomTableView;

@property(nonatomic, strong) UIView * middleView;


@end



@implementation ViewController

- (UIView *)middleView {
    if (!_middleView) {
        _middleView = [[UIView alloc] initWithFrame:CGRectMake(0, 0, self.view.frame.size.width, 100)];
        _middleView.backgroundColor = [UIColor orangeColor];
    }
    return _middleView;
}

- (UITableView *)bottomTableView {
    if (!_bottomTableView) {
        _bottomTableView = [[UITableView alloc] initWithFrame:CGRectMake(0, CGRectGetMaxY(self.tableView.frame), self.view.frame.size.width, self.view.frame.size.height) style:UITableViewStylePlain];
        _bottomTableView.tag = 200;
    }
    return _bottomTableView;
}

- (void)viewDidLoad {
    [super viewDidLoad];
    
    self.title = @"player";
    
    [self initUserInterface];

}

- (void)initUserInterface {
    
    UITableView * tableView = [[UITableView alloc] initWithFrame:self.view.bounds style:UITableViewStylePlain];
    [self.view addSubview:tableView];
    tableView.delegate = self;
    tableView.dataSource = self;
    self.tableView = tableView;
    _tableView.tag = 100;
    
    tableView.tableFooterView = self.middleView;
    
//    self.bottomTableView.tableHeaderView = self.middleView;

//    [self.view addSubview:self.bottomTableView];
}


- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
    if (tableView.tag == 100) {
        return 1;
    }
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    if (tableView.tag == 100) {
        return 10;
    }
    return 8;
}


- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {

    

    if (tableView.tag == 100) {
        UITableViewCell * cell = [tableView dequeueReusableCellWithIdentifier:@"cellId"];
        
        if (!cell) {
            cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:@"cellId"];
        }
        cell.textLabel.text = @"我是上面部分的cell";
        
        return cell;
    }
    
    UITableViewCell * cell = [tableView dequeueReusableCellWithIdentifier:@"bottomCellId"];
    
    if (!cell) {
        cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:@"bottomCellId"];
    }
    cell.textLabel.text = @"我是下面部分的cell";
    
    return cell;

}


- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath {
    
    return 80;
    
}

- (void)scrollViewDidScroll:(UIScrollView *)scrollView {
    if (scrollView.tag == 100) {
        CGFloat height = scrollView.frame.size.height;
        CGFloat contentYoffset = scrollView.contentOffset.y;
        CGFloat distanceFromBottom = scrollView.contentSize.height - contentYoffset;
        
        if (distanceFromBottom < height) {
            NSLog(@"%s",__func__);
            
        }
    }
}


@end
